<?
require_once PRISCILLA_LOCAL_PATH . "adm/lib/nusoap.php";
$debug = false;

function get_local_version($connh)
{
    $query = "SELECT versione FROM priscilla";
    $rs = $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
    $row = $rs->fields;
    return $row[versione];
}

function get_local_files($dir)
{
    global $remote_files, $local_files, $count_path, $debug;
    if ($debug) echo "<br />looking for dir $dir ...";
    $handle = @opendir($dir);
    while ($file = @readdir($handle))
    {
        if (!ereg('^\.', $file))
        {
            $tempDir = $dir."/".$file;
            if (is_dir($tempDir))
            {
                get_local_files($tempDir);
            }
            else
            {
                $tempFile = substr_replace($tempDir, "", 0, $count_path);
                $f = array_key_exists($tempFile, $remote_files); // se e' un file i distribuzione
                if ($f)
                {
                    if ($debug) echo "<br />file $tempFile is a distribution file";
                    $local_files[$tempFile] = md5_file(PRISCILLA_LOCAL_PATH . $tempFile);
                }
            }
        }
    }
    closedir($handle);
    return $local_files;
}

if (!function_exists('md5_file'))
{
    function md5_file($file)
    {
        if(!file_exists($file))return false;
        else
        {
            $fd = fopen ($file, "r");
            $contents = fread ($fd, filesize ($file));
            fclose ($fd);
            return md5($contents);
        }
    }
}


if (!function_exists('array_diff_assoc'))
{

    function array_diff_assoc($array1, $array2)
    {
     foreach($array1 as $key => $value)
     {
         if(is_array($value))
         {
               if(!is_array($array2[$key]))
               {
                   $difference[$key] = $value;
               }
               else
               {
                   $new_diff = array_diff_assoc($value, $array2[$key]);
                   if($new_diff != FALSE)
                   {
                         $difference[$key] = $new_diff;
                   }
               }
           }
           elseif(!isset($array2[$key]) || $array2[$key] != $value)
           {
               $difference[$key] = $value;
           }
     }
     return !isset($difference) ? 0 : $difference;
    }

}

    // ----- GET_LAST_VERSION
    $serverpath = PRISCILLA_UPDATE_MIRROR."get_last_version.php";
    $client = new soapclient0($serverpath);
    if ($fault = $client->getError())
    {
        print "error: ". $fault;
    }
    $param = array (
        "prj" => SW_NAME
    );
    $last_version = $client->call("get_last_version", $param);
    if ($fault = $client->getError())
    {
        print "<br /><font color=\"red\"><b>".$fault."</b></font>";
    }

    $local_version = get_local_version($connh);
    $param = array ("prj" => SW_NAME, "from" => $local_version);
    $comment_last_version = stripslashes($client->call("get_comment_last_version", $param));
    if ($fault = $client->getError())
    {
        print "<br /><font color=\"red\"><b>".$fault."</b></font>";
    }
    unset($client);
    echo "<br /><br /><B><font color=\"navy\" size=\"3\">" . adm_update_tt_localver . ":" . $local_version;
    echo "<br />" . adm_update_tt_lastver . ":" . $last_version . "</font></B>";
    echo "<br /><br /><b>" . adm_update_tt_lastver_warning . "</b></td></tr></table>";
    echo "<table align=\"center\" class=\"table_border\" cellpadding=\"7\" cellspacing=\"1\" border=\"0\"><tr><td align=\"center\" valign=\"top\" class=\"insert_voice\">$comment_last_version</td></tr></table>";

    if (!isset($_POST['update_username']) && !isset($_POST['update_password']))
    {
        echo "<br /><table width=\"100%\" align=\"center\" class=\"table_border\" cellpadding=\"4\" cellspacing=\"1\" border=\"0\"><tr><td width=\"50%\" align=\"center\" class=\"button_out\"><form method=\"post\"><input class=\"insert_voice\" type=\"text\" name=\"update_username\"><br />" . adm_voice_uid . "</td>";
        echo "<td width=\"50%\" class=\"button_out\" align=\"center\"><input class=\"insert_voice\" type=\"password\" name=\"update_password\"><br />" . adm_voice_pwd . "</td>
        </tr>";
        echo "<tr><td colspan=\"2\" class=\"insert_voice\">" .
             adm_update_tt_getuserpass .
            "</i></td></tr>
        <tr><td colspan=\"2\" class=\"button_out\" align=\"center\">
        <input class=\"button_in awesome\" type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;!!! " . adm_update_but_activate . " !!!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\"></form></td></tr></table>";
        flush();
    }
    // ----- CLIENT_AUTH
    if (isset($_POST['update_username']) && isset($_POST['update_password']))
    {

        $mandragora_cookie = "./lib/mandragora_was_here.php";

        // si testa la presenza di mandragora
        // ottenendo il servizio locale cui chiedere autorizzazione

        if (file_exists($mandragora_cookie) && is_readable($mandragora_cookie)) {
            $login_failed = true;
            $mandragora_login_error = "UNKNOWN ERROR";

            $mandragora_cookie_content = file ($mandragora_cookie);
            $mandragora_get_auth_path = $mandragora_cookie_content[0];

            $update_ppath = PRISCILLA_LOCAL_PATH;


            if ($update_ppath{strlen($update_ppath) - 1} == '/')
                $update_ppath = substr($update_ppath, 0, -1);

            $client = new soapclient0($mandragora_get_auth_path);

            if ($fault = $client->getError())
                $mandragora_login_error =  $fault;
            else {
                $auth_param = array(
                    "priscilla_path" => $update_ppath,
                    "username" => $_POST['update_username'],
                    "password" => $_POST['update_password'],
                    "clientip" => $_SERVER['REMOTE_ADDR']
                );
    
                $rres = $client->call("mandragora_get_auth", $auth_param);
    
                if ($fault = $client->getError())
                    $mandragora_login_error =  $fault;
                else {
                    $login_failed = false;
                    $user_pass = explode(':', $rres);
                    $update_username = $user_pass[0];
                    $update_password = $user_pass[1];
                }
                unset($auth_param);
                unset($client);
            }
        } // if (file_exists


        if (isset($login_failed) && $login_failed) {
            die("<br /><br /><font color=\"red\"><b>" . "LOGIN ERROR: " . $mandragora_login_error . "</b></font><br /><br />\n");
        }

        $serverpath = PRISCILLA_UPDATE_MIRROR . "adms_client_auth.php";
        $client = new soapclient0($serverpath);
        if ($fault = $client->getError())
            print "error: ". $fault;

        $auth_param = array(
            "prj" => SW_NAME,
            "username" => $_POST['update_username'],
            "password" => $_POST['update_password'],
            "clientip"=> $_SERVER['REMOTE_ADDR']
        );

        $auth_result_return = $client->call("client_auth", $auth_param);
        unset($auth_param);
        if ($fault = $client->getError())
        {
            echo "<br /><br /><b>" . adm_update_err_auth . "</b>";
            //echo "<br /><FONT color=\"red\"><b>".$fault."</b></FONT>";
        }
        else
        {
            // si salva il restituito cookie di autenticazione
            $adms_cookie = $auth_result_return['return_key'];

            echo "<br />" . adm_update_msg_auth_ok . "<br /><br />";
            //************** CONTROLLO DEL DATABASE *******************
            echo "<br /><br />" . adm_update_tt_dbcheck_running . "...";
            flush();

            // ---- GET PROJECT INFO
            $serverpath = PRISCILLA_UPDATE_MIRROR . "adms_get_project_info.php";
    
            $client = new soapclient0($serverpath);
            if ($fault = $client->getError())
            {
                print "error: ". $fault;
            }
            $param = array(
                "prj" => SW_NAME,
                );
    
            $project_info = unserialize($client->call("get_project_info", $param));
    
            if ($fault = $client->getError()) {
                print "<br><font color=\"red\"><b>".$fault."</b></font>";
                flush();
            }
    
            $update_table_format = $project_info['table_format'];
            if (trim($update_table_format) == '')
            $update_table_format = "MyISAM";
    
            unset($client);

            //prendo la stringa serializzata nel server
            $serverpath = PRISCILLA_UPDATE_MIRROR . "adms_check_db.php";
            $client = new soapclient0($serverpath);
            if ($fault = $client->getError())
                print "error: ". $fault;

            $param = array(
                "prj" => SW_NAME,
                "version" => $last_version,
                "username" => $_POST['update_username'],
                "cookie" => $adms_cookie
            );

            $remote_obj = $client->call("get_db",$param);
            if ($fault = $client->getError())
                // per adesso qui commentiamo anche perchè torna errore ma oggetto db buono.. boh
                //print "<br /><font color=\"red\"><b>".$fault."</b></font>";
                ;

            //ritrasformo i dati del db
            $remote_obj = stripslashes($remote_obj);
            $remote_obj = unserialize($remote_obj);

            require PRISCILLA_LOCAL_PATH . "modules/update/lib/update_db.inc.php";

            echo "<br />" . adm_update_tt_dbcheck_compl;
            flush();
            unset($client);

            // ----- GET_ALL_FILES
            $serverpath = PRISCILLA_UPDATE_MIRROR."adms_get_all_files_md5.php";
            $client = new soapclient0($serverpath);
            if ($fault = $client->getError())
                print "error: ". $fault;

            $param = array(
                "prj" => SW_NAME,
                "version" => $last_version,
                "username" => $_POST['update_username'],
                "cookie" => $adms_cookie
                );
            $remote_files = unserialize($client->call("get_all_files_md5",$param));
            if ($fault = $client->getError())
            {
                print "<br /><font color=\"red\"><b>".$fault."</b></font>";
                flush();
            }
            unset($client);
            $count_path = strlen(PRISCILLA_LOCAL_PATH) + 1;
            $local_files = array();
            $local_files = get_local_files(PRISCILLA_LOCAL_PATH);
            $new_files = array_diff(array_keys($remote_files), array_keys($local_files));
            if ($debug)
            {
                echo "<br />Ci sono ".count($new_files)." files da creare";
                echo "<br /><br /> ------------------- I FILE SUL SERVER";
                print_r ($remote_files);
                echo "<br /><br /> ------------------- I FILE SUL LOCALE";
                print_r ($local_files);
                echo "<br /><br /> ------------------- I FILE NUOVI";
                print_r ($new_files);
            }
            foreach ($new_files as $val)
            {
                echo "<br />".PRISCILLA_LOCAL_PATH." + <b>$val</b> " . adm_update_tt_to_create_file;
                if (!file_exists(PRISCILLA_LOCAL_PATH.$val))
                    if (!@touch(PRISCILLA_LOCAL_PATH.$val))
                    {
                        $regsval = explode("/",$val);
                        $dirlevel = count($regsval);
                        $tmppath = PRISCILLA_LOCAL_PATH;
                        $tmpcounter = 0;
                        foreach ($regsval as $val)
                        {
                            if ($tmpcounter == $dirlevel) // e' l'ultimo pezzo => file
                            {
                                if (@touch($tmppath)) echo ".... " . adm_update_tt_file_created;
                                else echo "<br />" . adm_update_err_file_create . " " . $tmppath;
                            }
                            else
                            {
                                if (!file_exists($tmppath))
                                {
                                    if (!@mkdir($tmppath,0700)) // e' per forza una dir
                                        echo "<br />" . adm_update_err_dir_create . " " . $tmppath;
                                    else if ($debug) echo ".... " . adm_update_tt_dir_created . " " . $tmppath;
                                }
                                $tmppath .= $val."/";
                            }
                            $tmpcounter++;
                        }
                    }
                    else echo ".... " . adm_update_tt_file_created;
            }

            $local_files = array_diff_assoc($remote_files, $local_files);

            // pezza per diff_assoc manuale
            if (!is_array($local_files))
                $local_files = array();

            if ($debug)
            {
                echo "<h1>File da modificare</h1><pre>";
                print_r($local_files);
                echo "</pre>";
            }
            $tot_local = count($local_files);
            $c = 0;
            foreach ($local_files as $key=>$val)
            {
                $c_av++;
                echo "<script type=\"text/javascript\">
                var c;
                c = (200*$c_av)/$tot_local;
                c = Math.round(c);
                document.avanzamento.width = c;
                </script>";

                // ----- UPDATE
                $serverpath = PRISCILLA_UPDATE_MIRROR . "adms_update.php";
                if (isset($client)) unset($client);
                $client = new soapclient0($serverpath);
                if ($fault = $client->getError())
                {
                    print "error: ". $fault;
                }
                $update_param = array();

                $update_param = array(
                    "prj" => SW_NAME,
                    "file" => $key,
                    "version"=>$last_version,
                    "username" => $_POST['update_username'],
                    "cookie" => $adms_cookie
                );

                if ($debug) {echo "<br />array parametri : "; print_r($update_param);}
                $remote_content = base64_decode(stripcslashes($client->call("update_file", $update_param)));

                if ($fault = $client->getError())
                {
                    print "<br /><font color=\"red\"><b>".$fault."</b></font>";
                }
                else
                {
                    $fd = @fopen(PRISCILLA_LOCAL_PATH . $key, "wb");
                    if (!$fd) echo "<br />" . adn_update_err_open . " " . $key;
                    $nb = @fwrite($fd, $remote_content);
                    if ($debug) echo "<br />scritti in " . PRISCILLA_LOCAL_PATH . "$key $nb byte";
                    @fclose($fd);
                    echo "<br />" . $key . " " .  adm_update_tt_updated;
                    flush();
                    $c++;

                }
                unset($client);
            }
            if ($c == 0) echo "<br />" . adm_update_tt_no_update;
            else echo "<br />" . adm_update_tt_number_updated . ": " . $c;
            //aggiorna il numero di versione
            $query = "UPDATE priscilla SET versione='$last_version'";
            $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
            echo "<br />" . adm_update_tt_filecheck_compl;


            $modules_to_install = array();
            $moduledir = PRISCILLA_LOCAL_PATH . "modules";
            $vtable_modules_file = PRISCILLA_LOCAL_PATH . "lib/vtable_mod.inc.php";
            $want_output = false;
    
            $handle = opendir($moduledir);
            while (false !== ($file = readdir($handle)))
                if (!ereg('^\.', $file)) {
                    $module_data_dir = PRISCILLA_LOCAL_PATH . "modules/$file/data";
                    if (!file_exists($module_data_dir))
                    mkdir($module_data_dir, 0700);
                        $modules_to_install[] = $file;
                }
            closedir($handle);
    
            if (count($modules_to_install))
            create_modules_vtable ($modules_to_install, $moduledir, $vtable_modules_file);

        }
    }
?>
