<?php
// $Id: page_del.php 5140 2012-04-11 15:02:10Z calicant $
//
// page_del.php
//
// ci si occupa di cancellare una pagina ed eventualmente di assegnare i figli ad altro nodo
// controllo di appartenenza della pagina da cancellare e del nodo di destinazione figli
// per utenti che non siano superuser
//
// la index (id = 1) o una pagina non avente genitori non si cancella

$debug = 0;

require "adm/lib/setup.php";
require "adm/lib/test_auth.php";

// toglobaloff
if (isset($_POST['action']))
    $action = $_POST['action'];
else if (isset($_GET['action']))
    $action = $_GET['action'];

if (isset($_POST['id']))
    $id = $_POST['id'];
else if (isset($_GET['id']))
    $id = $_GET['id'];

if (isset($_POST['destnode']))
    $destnode = $_POST['destnode'];
else if (isset($_GET['destnode']))
    $destnode = $_GET['destnode'];

if (isset($_POST['id_page_todelete']))
    $id_page_todelete = $_POST['id_page_todelete'];
else if (isset($_GET['id_page_todelete']))
    $id_page_todelete = $_GET['id_page_todelete'];

if (isset($_POST['content_table']))
    $content_table = $_POST['content_table'];
else if (isset($_GET['content_table']))
    $content_table = $_GET['content_table'];

if (isset($_POST['nome_pagina']))
    $nome_pagina = $_POST['nome_pagina'];
else if (isset($_GET['nome_pagina']))
    $nome_pagina = $_GET['nome_pagina'];


$subdel = array();
$subpage_not_yours = 0;

$is_a_root_page = false;

function stampa_tenda_assegnamento($currid) {
global $connh, $subdel;

    $subdel[] = $currid;
    navtree($currid, $connh);

    if ($debug) {
        print_r($subdel);
        echo "conta: " . count($subdel) . "<br \>";
    }
        
echo

    "<select name=destnode>\n" .
    "<option value=\"delete_all_daughters\">" . " " . dialog_pagedel_opt_title . " " . "</option>\n";
     
    if ($_COOKIE['login'] == 'superuser')
        $part_where = "";
    else
        $part_where = " WHERE id_user = '".$_COOKIE['login']."'";


    $dbquery = "SELECT id as content2_id, id_parent as content2_id_parent, id_user, sezione as content2_sezione FROM node $part_where ORDER BY sezione";
    $rowrs = $connh->Execute($dbquery);
    while (!$rowrs->EOF) {
        $row_sost = $rowrs->fields;
        if (!in_array($row_sost[content2_id], $subdel))
            print "<option value=\"$row_sost[content2_id]\">".$row_sost[content2_sezione].", ".$row_sost[content2_id]."</option>\n";
        $rowrs->MoveNext();
    }
    
    // si stampano pagine cui assegnare, ma non i figli di quella pagina
 
    echo "\n</select>\n";
        
} // stampa_tenda_assegnamento


// naviga alla ricerca dei figli della pagina da seccare
// verifica che tutte le pagine siano dell proprietario

function navtree($id, $connh) {
global $subdel, $subpage_not_yours;

    $dbquery = "SELECT id, id_parent, id_user, sezione FROM node WHERE id_parent='$id'";

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
    if ($rowrs->RecordCount() > 0)
        while (!$rowrs->EOF) {
            $row = $rowrs->fields;
            $subdel[]  = $row[id];    
            if ($_COOKIE['login'] != 'superuser')
                if ($row[id_user] != $_COOKIE['login'])
                    $subpage_not_yours++;                    
            navtree($row[id], $connh);
            $rowrs->MoveNext();
        }
}

function deltree($id, $connh)
{
    global $content_table;
    $dbquery = "SELECT id FROM node WHERE id_parent='$id'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    $dbquery1 = "DELETE FROM node WHERE id='$id'";
    $rowrs2 = $connh->Execute($dbquery1) or die("ERROR: $dbquery1<br />".$connh->ErrorMsg());
    
    $dbquery2 = "DELETE FROM $content_table WHERE id='$id'";
    $rowrs3 = $connh->Execute($dbquery2) or die("ERROR: $dbquery2<br />".$connh->ErrorMsg());

    $dbquery3 = "DELETE FROM metaname WHERE id='$id'";
    $rowrs4 = $connh->Execute($dbquery3) or die("ERROR: $dbquery3<br />".$connh->ErrorMsg());
    
    $dbquery = "DELETE FROM menunode WHERE id_node='$id'";
    $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    $rssez = $connh->Execute("SELECT sezione FROM node WHERE id='$id'");
    $dbquery3 = "UPDATE node SET areatematica='' WHERE areatematica='".$rssez->fields['sezione']."'";
    $rowrs4 = $connh->Execute($dbquery3) or die("ERROR: $dbquery3<br />".$connh->ErrorMsg());

    if ($rowrs->RecordCount()>0)
    while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        deltree($row[id], $connh);
        $rowrs->MoveNext();
    }
} // deltree


$usertable = $PRISCILLA_SESSION->getvalue('usertable');
if ($usertable[skin] != '') $skin = $usertable[skin];
if ($usertable[lingua] != '') $lang = $usertable[lingua];

require_once "tools/lang/$lang/dialog.diz";
require_once "tools/lang/$lang/error.diz";  

$delete_ok = 0;

// un controllo iniziale sull'id

if (($action != "reassign_page") && (!isset($id) || !is_numeric($id)))
    die("Fatal Error: invalid id '$id'\n");

// qui si fanno le varie operazioni

if ($action == 'del_prep') {


    // prendiamo info dell'id da cancellare    
    $dbquery = "SELECT id, id_parent, sezione, contenuto FROM node WHERE id='$id'";
    $rowrs2 = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    if ($rowrs2->RecordCount() < 1)
        die("Fatal Error: page with id = '$id' does not exist\n");
  
    $dbquery = "SELECT id FROM node WHERE id = '" . $rowrs2->fields('id_parent') . "'";
    $rowparent = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());


//    echo "genitori: " . $rowparent->RecordCount() . "*parent is: " . $rowrs2->fields('id_parent') . "*id is:" . $id . "<br />";

    if ($rowparent->RecordCount() == 0 || $id == 1 || $rowrs2->fields('id_parent') == 0) {

    $is_a_root_page = true;
    } else {

    $parow = $rowrs2->fields;
    $nome_pagina =   $parow[sezione];
    $content_table = $parow[contenuto];
    
    // vediamo se ci sono figli e quanti (almeno quelli di 'primo livello')
    if ($_COOKIE['login'] == 'superuser')
        $mywhere = "";
    else
        $mywhere = " AND id_user='".$_COOKIE['login']."'";

    $dbquery = "SELECT id, id_parent, id_user, sezione FROM node WHERE id_parent='$id'";    

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    $elenco_figlie = $rowrs;
    $numero_pagine_figlie = $rowrs->RecordCount();
    }
}

if ($action == 'reassign_page') {

    // anche questo ha da esserci
    if(!isset($_POST['destnode']))
        die("Fatal Error: destnode is undefined\n");

    // toglobaloff
    $destnode = $_POST['destnode'];   
 
    // si fanno alcuni importanti controlli in fase di cancellazione
    // 1. che sia dell'utente la pagina da cancellare
    // 2. che l'id della pagina padre cui eventualmente attaccare le figlia si dell'utente
    // superuser non ha limitazioni

    $ownerok = 1;

    if ($_COOKIE['login'] != 'superuser') {
        // verifica appartenenza pagina da cancellare
        $dbquery  = "SELECT id, id_user FROM node WHERE id='$id_page_todelete' AND id_user='".$_COOKIE['login']."'";                
        $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        if ($rowrs->RecordCount() != 1) {
            $ownerok = 0;
            $del_err_message = err_pagedel_notowner;
        }
        
        // se abbiam passato il primo controllo, verifica che l'eventuale la pagina di destinazione sia "nostra"
        if ($ownerok && $destnode != "delete_all_daughters") {
            $dbquery  = "SELECT id, id_user FROM node WHERE id='$destnode' AND id_user='".$_COOKIE['login']."'";
            $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
            if ($rowrs->RecordCount() != 1) {
                $ownerok = 0;
                $del_err_message = err_pagedel_destnotown . " (id = '" . $destnode . "')";
            }
       }
     
       // verifica se nel sottoramo ci sono pagine non "nostre"
       // si preferisce ricontrollare
       if ($ownerok && $destnode == "delete_all_daughters") {
            $subpage_not_yours = 0;
            navtree($id_page_todelete, $connh);
            if ($subpage_not_yours) {
                $ownerok = 0;
                $del_err_message = err_pagedel_subtreeown . ": " . $subpage_not_yours;
            } // if
       } // if
       
    } // if ($login...

    // si verifica di non avere a che fare con un id pari a 1 o inferiore    
    if ($ownerok && $id_page_todelete < 2) {
        $ownerok = 0;
        $del_err_message = err_pagedel_lowid;
    }

    // si prepara la pagina di ritorno
    if ($ownerok) {
        //query per avere l'id_parent
        $dbquery = "SELECT id_parent FROM node WHERE id='$id_page_todelete'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        $rowreturn = $rowrs->fields;
        $id_return = $rowreturn['id_parent'];
    }        
   
    // si verifica se si vuole cancellare tutto o meno
    if ($ownerok && $destnode == "delete_all_daughters") {
    
        deltree($id_page_todelete, $connh);
        $delete_ok = 1;
        
    } else if ($ownerok) {
    
        // cancellazione della pagina e suo contenuto
        $dbquery = "DELETE FROM node WHERE id='$id_page_todelete'";
        $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

        $dbquery = "DELETE FROM $content_table WHERE id='$id_page_todelete'";
        $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
        $dbquery = "DELETE FROM metaname WHERE id='$id_page_todelete'";
        $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
        $dbquery = "DELETE FROM menunode WHERE id_node='$id_page_todelete'";
        $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

        // assegnazione dei figli
        $dbquery = "UPDATE node SET id_parent=$destnode,lastmod=NOW() WHERE id_parent='$id_page_todelete'";
        $connh->Execute($dbquery)  or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
        // se siamo arrivati qui vuol dire che abbiamo cancellato...
        
        $delete_ok = 1;
    }

    // automaticamente indietro NON si torna
    // header("Location: index.php?id=$id_return");
}

print "<head><title>" . dialog_pagedel_tt_del . "</title>\n";
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/$skin/default.css\">\n";
print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/ie6.css\" />
		<![endif]-->";

if ($is_a_root_page)
    echo "<meta http-equiv=\"refresh\" content=\"3; url=index.php\">\n";

echo "</head>\n";
include("adm/skin/$skin/body.inc");
include("adm/include/head_popup.inc.php");

if ($is_a_root_page)
    die("<div align=\"center\" class=\"insert_message\"><strong>err_pagedel_warn</strong></div><br /><br /><br /></body>\n</html>\n");   

?>
<form method="post">
<?php
if (isset($lastaction))
echo "<input type=\"hidden\" name=\"lastaction\" value=\"$lastaction\">\n";
?>
<table class="table_border" width="<? include ("adm/include/dim_all.inc.php"); ?>" align="center" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th colspan=2 class="table_tit"><? echo dialog_pagedel_tt_del .  " \"" . strtoupper($nome_pagina) . "\""; ?></th>
</tr>

<?php
if  ($action != "reassign_page") {

    echo "<tr><td colspan=\"2\" align=\"center\" class=\"table_sez\">" .
        dialog_pagedel_tt_warn .
        "</td></tr>\n";

    if ($numero_pagine_figlie) {
        echo "<tr><td colspan=\"2\" align=\"center\" class=\"table_sez\">" .
            dialog_pagedel_tt_numdaught . ":&nbsp;<strong>" . $numero_pagine_figlie . "</strong>.&nbsp;" .
            dialog_pagedel_tt_reassign. "</td></tr>\n";

        // stampa l'elenco dei figli di primo livello

        echo
            "<tr><th align=\"center\" class=\"table_tit\" width=\"20\">" .
            dialog_gen_id .
            "</th><th align=\"center\" class=\"table_tit\">" .
            dialog_gen_sez .
            "</th></tr>";

        while (!$elenco_figlie->EOF) {
            $crow = $elenco_figlie->fields;
            echo
                "<tr><td width=\"30\" align=\"center\" class=\"table_sez\">" . $crow['id'] . "</td>" .                
                "<td class=\"table_sez\">" . strtoupper($crow['sezione']) .  "</td></tr>\n";                
            $elenco_figlie->MoveNext();
        } // while
        
            
        echo
            "<tr><td colspan=\"2\" align=\"center\" class=\"table_sez\">" . dialog_pagedel_tt_action . ": ";
        stampa_tenda_assegnamento($id);
        echo "</td></tr>";
    }
    // se non c'&Egrave; tendina d'assegnamento non ci sono figle da assegnare
    else
        echo "<input type=\"hidden\" name=\"destnode\" value=\"delete_all_daughters\">";
        
    echo
        "<input type=\"hidden\" name=\"action\" value=\"reassign_page\">" .
        "<input type=\"hidden\" name=\"id_page_todelete\" value=\"$id\">" .
        "<input type=\"hidden\" name=\"content_table\" value=\"$content_table\">" .
        "<input type=\"hidden\" name=\"nome_pagina\" value=\"$nome_pagina\">";
        
    if (isset($lastaction))
        $cancel_link = "tools.php?action=show_tree&id_node=1";
    else
        $cancel_link = "index.php?id=$id";
                    
    echo        
        "<tr><td colspan=\"2\" align=\"center\" class=\"button_out\">" .
        "<input type=\"button\" onclick='document.location.href=\"" . $cancel_link . "\";' ".
        "class=\"button_in awesome\" value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . dialog_but_cancel . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp\">" .
        "<input type=\"submit\" ".
        "value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".pan_save."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\" class=\"button_in awesome\"></td></tr>";
        
        

        
} else {

    if ($delete_ok)
        $res_message = dialog_pagedel_msg_ok;
    else
        $res_message = err_pagedel_msg_no;

    if (isset($del_err_message))
        $res_message .= "<br />" . $del_err_message;


    // si stampa il risultato dell'operazione
    echo "<tr><td align=\"center\" class=\"table_sez\">$res_message</td></tr>";
    
    if ($delete_ok)
        $idback = $id_return;
    else
        $idback = $id_page_todelete;

    if (isset($lastaction))
        $returnlink = "tools.php?action=show_tree&id_node=1";        
    else
        $returnlink = "index.php?id=$idback";
        
    echo "<tr><td align=\"center\" class=\"table_link\"><a href=\"" . $returnlink . "\">" . dialog_pagedel_tt_go . "</a></td></tr>";
    
    
}
?>
</table></form>
</body></html>
