<?
// $Id: community_linear.inc.php 5140 2012-04-11 15:02:10Z calicant $

require_once PRISCILLA_LOCAL_PATH."modules/community/lang/".LANG."/community.diz";
require_once PRISCILLA_LOCAL_PATH."tools/lang/".LANG."/dialog.diz";

/**
 ** tag: communityregistrazione
 ** desc: stampa il form di registrazione della community
 ** opt: id obbligatorio, id della community
 ** opt: privacy id della pagina contenente le informazioni di privacy per la raccolta dei dati utente
 **/
function communityregistrazione ($connh, $row, &$PRISCILLA_SESSION, $options)
{

    $unwanted_fields = array ('id_community','id','isactivestatus','activationcookie','time_request','time_activation','time_remove');
    $default_fields = array('username', 'password', 'email');

    $id_community = $options['id'];

    $is_a_datatonic_community = 0;
    $dbquery = "SELECT datatonic_community FROM community WHERE id = '" . $id_community . "'";
    $rstype = $connh->Execute($dbquery);
    if ($rstype && $rstype->RecordCount() >= 1)
        $is_a_datatonic_community = $rstype->fields('datatonic_community');


    $subst .= "<form action=\"modules/community/lib/community_registration.php\" method=\"post\" id=\"communityform\">
    <fieldset>
    <input type=\"hidden\" name=\"idp\" id=\"idp\" value=\"$row[id]\" />
    <input type=\"hidden\" name=\"id_community\" id=\"id_community\" value=\"$id_community\" /></p>";
    if ($PRISCILLA_SESSION->getvalue('community_reg_msg') != '') {
        $subst .= "<div class=\"community_msg\">".$PRISCILLA_SESSION->getvalue('community_reg_msg')."</div>";
        $PRISCILLA_SESSION->remove('community_reg_msg');
    }
    else {

    if (!$is_a_datatonic_community) {

        $subst .= "<input type=\"checkbox\" name=\"community_exist\" id=\"community_exist\" value=\"ok\" class=\"community_input\" onclick=\"setExistFields(this.checked)\" /><label for=\"community_exist\">".community_existent."</label><br />";
    }

    $jsExistFields = "function setExistFields(checked) {
    fields = new Array();\n";

    $filled = $PRISCILLA_SESSION->getvalue('community_filled');

    // informazione sui campi
    $fi = $connh->MetaColumns("community_user_content");

    $query = "SELECT * FROM community_user_content";
    $rs = $connh->Execute($query) or die("ERR: $query<br />".$rs->ErrorMsg());
    for ($i=0; $i<$rs->FieldCount(); $i++)
    {
        $field = $rs->FetchField($i);
        if (!in_array($field->name, $unwanted_fields))
        {
            //riprendo i valori dalla sessione se c'e' stato un errore
            if (isset($filled[$field->name]))
                $val = $filled[$field->name];
            else
                $val = $field->name;

            $m_type = $rs->MetaType($field->type);
            $query = "SELECT * FROM community_userFields WHERE nome='".$field->name."'";
            $rs2 = $connh->Execute($query) or die("ERR: $query<br />".$rs2->ErrorMsg());
            
            // se il campo non è stato configurato per essere usato con questa community lo si salta
            $comms = explode(',', $rs2->fields['id_community']);
            if (!in_array($options['id'], $comms) && !in_array($field->name, $default_fields))
                continue;

            if (!in_array($field->name, $default_fields))
                $jsExistFields .= "fields.push('".$field->name."');\n";

            // se il campo e' un enumeratore
            $is_enum_field = false;
            $up_key = strtoupper($field->name);
            if (isset($fi[$up_key])) {

                $fo = $fi[$up_key];

                if (substr($fo->type, 0, 4) == 'enum') {
                    $a_enum_values = explode(',', str_replace("'", "", substr($fo->type, 5, strlen($fo->type) -6)));
                    $is_enum_field = true;
                }
            }
            

            if ($is_enum_field) {
                $tipo =
                "<select class=\"community_input\" name=\"" . $field->name . "\" id=\"" . $field->name . "\" size=\"1\">\n" .
                "<option value=\"\"></option>\n";
                foreach ($a_enum_values as $v)
                    $tipo .= "<option value=\"$v\">$v</option>\n";
                $tipo .= "</select>\n";

            }
            else {

                if ($field->name == 'password')
                    $tipo = "<input name=\"".$field->name."\" id=\"".$field->name."\" type=\"password\" class=\"community_input\" />";
                elseif ($m_type == 'X')
                    $tipo = "<textarea name=\"".$field->name."\" id=\"".$field->name."\" class=\"community_input\" onfocus=\"if (this.innerHTML == '".$field->name."') this.innerHTML=''\">$val</textarea>";
                elseif ($m_type == 'C')
                    $tipo = "<input name=\"".$field->name."\" id=\"".$field->name."\" type=\"text\" value=\"$val\" onfocus=\"if (this.value == '".$field->name."') this.value=''\" class=\"community_input\" />";
                elseif ($m_type == 'N')
                    $tipo = "<input name=\"".$field->name."\" id=\"".$field->name."\" type=\"text\" value=\"$val\" onfocus=\"if (this.value == '".$field->name."') this.value=''\" class=\"community_input\" />";
                elseif ($m_type == 'D') {
                    $adate = explode('-', $val);
                    $tipo = "<select name=\"".$field->name."_dated\" id=\"".$field->name."_dated\" type=\"text\" value=\"".$adate[0]."\" class=\"community_input\" />";
                    for ($r = 1; $r <= 31; $r++)
                        $tipo .= "<option value=\"".$r."\">".$r;
                    $tipo .= "</select><select name=\"".$field->name."_datem\" id=\"".$field->name."_datem\" type=\"text\" value=\"".$adate[1]."\" class=\"community_input\" />";
                    for ($r = 1; $r <= 12; $r++)
                        $tipo .= "<option value=\"".$r."\">".$r;
                    $tipo .= "</select><input name=\"".$field->name."_datey\" id=\"".$field->name."_datey\" type=\"text\" value=\"".$adate[2]."\" size=\"4\" maxlength=\"4\" class=\"community_input\" />";
                }
            }

            $subst .= "<label for=\"". $field->name . "\">".$field->name."</label>";
            if (in_array($field->name, $default_fields) || $rs2->fields('obbligatorio') == 'true')
                $subst .= ' *';
            $subst .= $tipo."<br />";
            if ($field->name == 'password')
                $subst .= "<label for=\"".$field->name."\">" . community_password_repeat . " password *</label><input name=\"password2\" id=\"password2\" type=\"password\" class=\"community_input\" /><br />";
        }
    }

    $jscheck = "else document.forms.communityform.submit();";
    if (is_numeric($options['privacy']) && $options['privacy']) {
        $subst .= "<div class=\"community_privacy\" style=\"float:left;\">
        <input type=\"checkbox\" name=\"privacy\" id=\"privacy\" /> ".community_privacy." <a href=\"index.php?id=".$options['privacy']."\" class=\"community_privacy_link\" title=\"".community_privacy_link."\">privacy</a>
        </div>";
        $jscheck = "else { if (document.forms.communityform.privacy.checked == false) alert('".community_privacy_accepted."'); else document.forms.communityform.submit();}";
    }

    $subst .= "<input type=\"button\" value=\"".community_submit."\" class=\"community_button\" onclick=\"if (document.forms.communityform.password.value != document.forms.communityform.password2.value) alert('" . community_password_dont_match . "'); ".$jscheck."\" id=\"butt_send\" />
    </fieldset>
    </form>";

    $jsExistFields .= "for (i = 0; i < fields.length; i++) {
        if (checked)
            document.getElementById(fields[i]).disabled = true;
        else
            document.getElementById(fields[i]).disabled = false;
        }
    }";

    }
    return "<script type=\"text/javascript\">".$jsExistFields."</script>".$subst;
}

/**
 ** tag: communitylogin
 ** desc: stampa il form di login alla community
 ** opt: id id della community, se non fornito il login e` valido per tutte le community del sito
 ** opt: redirect id della pagina di "atterraggio" in caso di login valido
 ** opt: redirectout id della pagina di "atterraggio" in caso di logout 
 ** opt: error id della pagina di errore (se non specificato, la pagina di errore è quella della community verso cui si dovrebbe redirezionare)
 **/
function communitylogin ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $community_user = $PRISCILLA_SESSION->getvalue('community_user');
    $is_my_community = true;
	
	if ($options['redirectout'] != '')
        $idpout = $options['redirectout']; // id pagina di redirezione in logout
    else
        $idpout = $row['id'];   

    if ($options['redirect'] != '')
        $idp = $options['redirect']; // id pagina di redirezione
    else
        $idp = $row['id'];
    if ($options['id'] != '') {
        $idc = $options['id']; // id community
        if ($community_user) {
            $user_community_nodes = explode(",", $community_user->get('id_community'));
            if (!in_array($idc, $user_community_nodes)) 
                $is_my_community = false;
        }
    }
    else $idc = '';

    if ($community_user && $is_my_community) {
        if ($PRISCILLA_SESSION->getvalue('community_login_msg') != '') {
            $subst .= "<div class=\"community_msg\">".$PRISCILLA_SESSION->getvalue('community_login_msg')."</div>";
            $PRISCILLA_SESSION->remove('community_login_msg');
        }
        if ($idc) $idcg = '&idc='.$idc;
        else $idcg = '';
        $uobj = $PRISCILLA_SESSION->getvalue("community_user");
    	if (is_object($uobj)) $subst = "Benvenuto ".$uobj->get("username")."! ";
        $subst .= "[<a class=\"community_logout\" title=\"LOGOUT\" href=\"modules/community/lib/community_login.php?idp=$idpout&action=logout".$idcg."\">LOGOUT</a>]<br />";
        $subst .= "<p class=\"communityarea\">Vai all' <a class=\"communitytitle\" href=\"index.php?id=$idp\">{getnodeinfo target=\"$idp\" type=\"content\" field=\"titolo\"}</a></p>";
    }
    else {
        $subst = "<div class=\"community_table\">
        <form action=\"modules/community/lib/community_login.php\" method=\"post\">
        <p><input type=\"hidden\" name=\"idp\" id=\"idp\" value=\"$idp\" />
        <input type=\"hidden\" name=\"idpout\" id=\"idpout\" value=\"$idpout\" />
        <input type=\"hidden\" name=\"ide\" id=\"ide\" value=\"".$options['error']."\" />
        <input type=\"hidden\" name=\"idc\" id=\"idc\" value=\"$idc\" /></p>";
        $subst .= "<div class=\"community_td\" style=\"float:left\"><label for=\"community_username\">USERNAME</label></div>
            <div class=\"community_td\" style=\"float:left\"><input type=\"text\" name=\"community_username\" value=\"username\" id=\"community_username\" class=\"community_input\" onfocus=\"javascript:this.value=''\" /></div>
        <div style=\"clear:left\"></div>
            <div class=\"community_td\" style=\"float:left\"><label for=\"community_password\">PASSWORD</label></div>
            <div class=\"community_td\" style=\"float:left\"><input type=\"password\" name=\"community_password\" id=\"community_password\" class=\"community_input\" /></div>
        <div style=\"clear:left\"></div>
            <div class=\"community_td\"><input type=\"submit\" value=\"LOGIN\" class=\"community_button\" id=\"butt_login\" /></div>
        </form>
        </div>";
    }

    return $subst;
}

/**
 ** tag: communitychpassw
 ** desc: stampa il form cambio password
 **/
function communitychpassw ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $community_user = $PRISCILLA_SESSION->getvalue('community_user');

    if (!$community_user)
        return '';

    $subst = "<table  class=\"community_table\">
    <form method=\"post\" action=\"modules/community/lib/community_chpassw.php\">
    <p>
    <input type=\"hidden\" name=\"idp\" id=\"idp\" value=\"$row[id]\" />";
    if ($PRISCILLA_SESSION->getvalue('community_chpassw_msg') != ''){ $subst .= "<tr><td colspan=\"2\"
class=\"community_msg\">".$PRISCILLA_SESSION->getvalue('community_chpassw_msg')."</td></tr>";
    $PRISCILLA_SESSION->remove('community_chpassw_msg');}
    $subst .= "<tr>
    <td class=\"community_td\"><label for=\"oldpassw\">".dialog_comm_oldpsw."</label></td>
    <td class=\"community_td\"><input type=\"password\" name=\"oldpassw\" id=\"oldpassw\" value=\"".dialog_comm_oldpsw."\" class=\"community_input\" onfocus=\"javascript:this.value=''\" /></td>
    </tr><tr>
    <td class=\"community_td\"><label for=\"newpassw\">".dialog_comm_newpsw."</label></td>
    <td class=\"community_td\"><input type=\"password\" name=\"newpassw\" id=\"newpassw\" class=\"community_input\" value=\"".dialog_comm_newpsw."\" onfocus=\"javascript:this.value=''\" /></td>
    </tr><tr>
    <td class=\"community_td\"><label for=\"newpassw2\">".dialog_comm_repnewpsw."</label></td>
    <td class=\"community_td\"><input type=\"password\" name=\"newpassw2\" id=\"newpassw2\" class=\"community_input\" value=\"".dialog_comm_repnewpsw."\" onfocus=\"javascript:this.value=''\" /></td>
    </tr><tr>
    <td class=\"community_td\" colspan=\"2\"><input type=\"submit\" value=\"ESEGUI\" id=\"butt_exec\" /></td>
    </tr>
    </p>
    </form>
    </table>";

    return $subst;
}

/**
 ** tag: communitylogout
 ** desc: stampa il link per effettuare il logout
 ** opt: id id della community, se non fornito il logout e` valido per tutte le community del sito
 ** opt: redirect id della pagina di "atterraggio" dopo il logout
 **/
function communitylogout ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $community_user = $PRISCILLA_SESSION->getvalue('community_user');
    $is_my_community = true;

    $opts = explode("_",$tagname);
    if ($options['id'] != '') {
		$idc = $options['id'];
        	$idcg = '&idc='.$idc;
    }
    else {
        $idc = '';
        $idcg = '';
    }


    if ($options['redirect'] != '') {
        //$idc = $options['redirect']; // id community
        //$idcg = '&idc='.$idc;
	$idp = $options["redirect"];
        if ($community_user) {
            $user_community_nodes = explode(",", $community_user->get('id_community'));
//            if (!in_array($idc, $user_community_nodes)) 
//                $is_my_community = false;
        }
    }
    else
	$idp = $row["id"];

    if ($community_user && $is_my_community)
        $subst = "<a class=\"community_logout\" title=\"LOGOUT\" href=\"modules/community/lib/community_login.php?idp=$idp&action=logout".$idcg."\">LOGOUT</a>";
    else $subst = '';

return $subst;
}

/**
 ** tag: communitygetusername
 ** desc: ritorna lo username dell'utente loggato
 **/
function communitygetusername ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $uobj = $PRISCILLA_SESSION->getvalue("community_user");
    if (is_object($uobj)) $subst = $uobj->get("username");

    return $subst;
}
?>
