<?php

// $Id: nlsubscribe.php 5140 2012-04-11 15:02:10Z calicant $

require "../../../adm/lib/setup.php";
require "../../../adm/lib/priscilla_session_init.inc.php";
require "../inc/config.inc.php";

if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' &&  file_exists('../lang/'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang').'/newsletter.diz'))
    $lang = $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

require "../lang/$lang/newsletter.diz";


function comeback($idp, $message) {

    $message = bzcompress($message);
    $message = base64_encode($message);
    $message = str_replace("=", "!", $message);
    $message = str_replace("+", "|", $message);

    header("Location: ../../../index.php?id=$idp&newsletter_sub_message=" . $message);
    die();
}

function generateCookie ($item1, $item2) {
    srand ((float) microtime() * 10000000);
    $random_middle = rand();
    $mypreid = $item1 . $random_middle . $item2;

return md5($mypreid);
}

// controllo che il newsletter id sia presente

function newsletter_exists($connh, $nlid, &$from, &$newsletter_name) {

    $dbquery = "SELECT name, frommail FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$nlid'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
        // si prende l'email del mittende per le email in uscita
        $from = $rowrs->fields('frommail');
        $newsletter_name = $rowrs->fields('name');
	return 1;
    }


return 0;
}

function nlSendMail($from, $to, $subject, $message) {
global $smtpserver, $smtpuser,  $smtprealm, $smtppassw;


    if (!function_exists("GetMXRR")) {
	$_NAMESERVERS = array();
	require("../../../packages/smtp/getmxrr.php");
    }
    require ("../../../packages/smtp/smtp.php");


    $smtp = new smtp_class;
    $smtp->host_name = $smtpserver; /* relay SMTP server address */
    $smtp->localhost = "localhost";         /* this computer address */
    $smtp->direct_delivery = 0;     /* Set to 1 to deliver directly to the recepient SMTP server */
    $smtp->debug = 0;               /* Set to 1 to output the communication with the SMTP server */
    $smtp->user = $smtpuser;        /* Set to the user name if the server requires authetication */
    $smtp->realm = $smtprealm;      /* Set to the authetication realm, usually the authentication user e-mail domain */
    $smtp->password = $smtppassw;   /* Set to the authetication password */


    $headers = array(
	"From: $from",
	"To: $to",
	"Subject: $subject",
	"X-Mailer: " . NEWSLETTER_MAILER_NAME . NEWSLETTER_VERSION,
	"Date: " . strftime("%a, %d %b %Y %H:%M:%S %Z")
    );

    if ($smtp->SendMessage(
	$from,
	array($to),
	$headers,
	$message
    ))
	return 1;
    else return 0;
}




//
// subito vediamo se &Egrave; una richiesta di conferma
//
if (isset($_GET['pid']) && is_numeric($_GET['pid']) && isset($_GET['email']) && isset($_GET['cookie']) && isset($_GET['nlid']) && is_numeric($_GET['nlid'])) {

    $activationcookie = md5($_GET['cookie']);


    // controllo se la newsletter esiste
    if (!newsletter_exists($connh, $nlid, $from, $newsletter_name))
	comeback($_POST['pid'], NEWSLETTER_ERROR_ACTIVATION . " \"$_GET[email]\"");

    // prima si vede se siamo in attesa di attivazione
    $dbquery = "SELECT id FROM " .  NEWSLETTER_TABLE_MAILDATA .
	" WHERE idmailg = '$_GET[nlid]' AND email = '$_GET[email]' AND activationcookie = '$activationcookie' AND isactivestatus = 'no'";

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($rowrs->RecordCount() == 1) {

	$adesso = time();

	$dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILDATA .
	    " SET isactivestatus = 'yes', time_activation = '$adesso' WHERE id = '" . $rowrs->fields('id') . "'";

	$rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

	// invio della email di conferma registrazione


	// indirizzo per la rimozione
	$server_path = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
	$link = $server_path . "?pid=" . $_GET['pid'] . "&nlid=" . $_GET['nlid'] . "&remove=" . $_GET['email'] . "&cookie=" . $_GET['cookie'];

	$subject = NEWSLETTER_CONFIRM_SUBJECT . ' ' . $newsletter_name;
	$message = NEWSLETTER_MAILCONFIRM_MESSAGE . "\n\n" . $link;
        

	if (nlSendMail($from, $_GET['email'], $subject, $message))
	    comeback($_GET['pid'], NEWSLETTER_ACTIVATION_OK . " \"$_GET[email]\"");
	else
	    comeback($_GET['pid'], NEWSLETTER_ACTIVATION_ALMOSTOK); 
    }
    else comeback($_GET['pid'], NEWSLETTER_ERROR_ACTIVATION . " \"$_GET[email]\"");
}


//
//  richiesta di rimozione
//
if (isset($_GET['pid']) && is_numeric($_GET['pid']) && isset($_GET['remove']) && (isset($_GET['cookie']) || isset($_GET['c']) ) && isset($_GET['nlid']) && is_numeric($_GET['nlid'])) {



    if (!newsletter_exists($connh, $nlid, $from, $newsletter_name))
	comeback($_POST['pid'], NEWSLETTER_ERROR_REMOVE . " \"$_GET[remove]\"");

    if (isset($_GET['cookie'])) {

        $activationcookie = md5($_GET['cookie']);

        $dbquery =
	    "DELETE FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$_GET[nlid]' AND email = '$_GET[remove]' AND activationcookie = '$activationcookie' AND isactivestatus = 'yes' LIMIT 1";

    }
    else {
        $activationcookie = md5($_GET['pid'] . "2005" . $_GET['nlid'] . "2005" . $_GET['remove']);
   
        if ($_GET['c'] == $activationcookie)
	        $dbquery = "DELETE FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$_GET[nlid]' AND email = '$_GET[remove]' LIMIT 1";
        else
            $dbquery = "DELETE FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE id = '-1' LIMIT 1";    

    }

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($connh->Affected_Rows() >= 1) {

	$subject = NEWSLETTER_REMOVE_SUBJECT . ' ' . $newsletter_name;
	$message = NEWSLETTER_REMOVE_MESSAGE . "\n\n" . $_GET['remove'];
	nlSendMail($from, $_GET['remove'], $subject, $message);
	comeback($_GET['pid'], NEWSLETTER_REMOVE_OK . " \"$_GET[remove]\"");

    }
    else comeback($_GET['pid'], NEWSLETTER_ERROR_REMOVE . " \"$_GET[remove]\"");	

}

/////////////////////////////////richiesta di iscrizione alla newsletter /////////////////////////


if (!isset($_POST['newsletter_page_id']) || !is_numeric($_POST['newsletter_page_id']))
    die("You cannot call this page directly.");


$email = trim($_POST['nlsub']['email']);

$password = trim($_POST['nlsub']['password']);
if ($password != '')
    $password = md5($password);


// controllo (minimale) dell'indirizzo email

if(!ereg("^[^@ ]+@[^@ ]+.[a-zA-Z]{2,4}$", $email))
    comeback($_POST['newsletter_page_id'], NEWSLETTER_ERROR_SUBSCRIPTION . " \"$email\""); 


// controllo se abbiamo l'id della newsletter
$nlid = trim($_POST['nlsub']['newsletterid']);

if (!isset($nlid) || trim($nlid) == '' || !is_numeric($nlid))
    comeback($_POST['newsletter_page_id'], NEWSLETTER_ERROR_ID);


// controllo che il newsletter id sia presente

if (!newsletter_exists($connh, $nlid, $from, $newsletter_name))
    comeback($_POST['newsletter_page_id'], NEWSLETTER_ERROR_UNKNOWN . ": ID = " . $nlid);


// controllo che l'indirizzo non sia gia' registrato o in attessa di conferma registrazione

$dbquery = "SELECT id FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE LOWER(email) = '" . strtolower($email) . "' AND idmailg = '$nlid'";
$rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());


if ($rowrs->RecordCount() > 0)
    comeback($_POST['newsletter_page_id'], NEWSLETTER_ERROR_SUBSCRIPTION . " \"$email\"");


// invio della email di conferma


// generazione cookie iscrizione e inserimento dati
$activationcookie = generateCookie($email, $name);
// indirizzo per la conferma della registrazione
$server_path = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
$link = $server_path . "?pid=" . $_POST['newsletter_page_id'] . "&nlid=" . $nlid . "&email=" . $email . "&cookie=$activationcookie";

$subject = NEWSLETTER_SUBSCRIPTION_SUBJECT . ' ' . $newsletter_name;		    
$message = NEWSLETTER_MAIL_MESSAGE . "\n\n" . $link;
		

if (nlSendMail($from, $email, $subject, $message))  {

	$adesso = time();

	$dbquery =
    		"INSERT INTO " . NEWSLETTER_TABLE_MAILDATA .
    		" (idmailg, email, activationcookie, password, isactivestatus, time_request) VALUES" .
    		" ('$nlid', '$email', '" . md5($activationcookie) . "', '$password', 'no', '$adesso')";

	$connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());
	comeback($_POST['newsletter_page_id'], NEWSLETTER_SUBSCRIPTION_OK . " " . $email);
}
else
	comeback($_POST['newsletter_page_id'], NEWSLETTER_ERROR_SUBSCRIPTION . "  " . $email . ".");

?>
